%Justin Lines 2014. This program reads in EMERGENT replay output files and
%creates an input file to train back in EMERGENT.

clear
filename=input('Give me the filename you wish to read: ','s');
file1='thirt32.dat';
file2='thirt33.dat';
file3='ten31.dat';
file4='ten32.dat';
threshold=0.6;
entry=6;
filer=csvread(filename);
object=zeros(size(filer,1),256);
day1=csvread(file1);
day2=csvread(file2);
day3=csvread(file3);
day4=csvread(file4);
number=size(day1,1);
correct1=zeros(size(day1,1),256);
correct2=zeros(size(day2,1),256);
correct3=zeros(size(day3,1),256);
correct4=zeros(size(day4,1),256);
count2=0;
count1=0;
count3=0;
count4=0;
neither=0;
num=0;
oner=0;
twor=0;
threer=0;
fourr=0;
one=0;
two=0;
threer=0;
fourr=0;

for i=1:size(filer,1)
    object(i,1:256)=filer(i,15:270);
end

for i=1:size(day1,1)
    correct1(i,1:256)=day1(i,2:257);
end

for i=1:size(day2,1)
    correct2(i,1:256)=day2(i,2:257);
end

for i=1:size(day3,1)
    correct3(i,1:256)=day3(i,2:257);
end

for i=1:size(day4,1)
    correct4(i,1:256)=day4(i,2:257);
end

for a=1:size(filer,1)
    p=0;
    q=0;
    r=0;
    s=0;
    c=0;
    for b=1:size(day1,1)
        un=sum(sum(correct1(b,1:256).*object(a,1:256)))/sqrt(sum(sum(correct1(b,1:256)))*sum(sum(object(a,1:256))));
        if un >= threshold && un > p
            p=un;
            closest1=b;
        end
    end
    for b=1:size(day2,1)
        deux=sum(sum(correct2(b,1:256).*object(a,1:256)))/sqrt(sum(sum(correct2(b,1:256)))*sum(sum(object(a,1:256))));
        if deux >= threshold && deux > q
            q=deux;
            closest2=b;
        end
    end
    for b=1:size(day3,1)
        trois=sum(sum(correct3(b,1:256).*object(a,1:256)))/sqrt(sum(sum(correct3(b,1:256)))*sum(sum(object(a,1:256))));
        if trois >= threshold && trois > r
            r=trois;
            closest3=b;
        end
    end
    for b=1:size(day4,1)
        quatre=sum(sum(correct4(b,1:256).*object(a,1:256)))/sqrt(sum(sum(correct4(b,1:256)))*sum(sum(object(a,1:256))));
        if quatre >= threshold && quatre > s
            s=quatre;
            closest4=b;
        end
    end
    if p == 0 && q == 0 && r==0 && s==0
        neither=neither+1;
    end
    if p > q && p > r && p > s
        count1=count1+1;
        c=1;
        closest=closest1;
    end
    if q > p && q > r && q > s
        count2=count2+1;
        c=2;
        closest=closest2;
    end
    if r > q && r > p && r > s
        count3=count3+1;
        c=3;
        closest=closest3;
    end
    if s > p && s > r && s > q
        count4=count4+1;
        c=4;
        closest=closest4;
    end
    if c ~= 0
        num=num+1;
        sample(num,1:3)=[c closest a];
        if c == 1
            oner=oner+1;
            one(oner)=closest;
        elseif c ==2
            twor=twor+1;
            two(twor)=closest;
        elseif c == 3
            threer=threer+1;
            three(threer)=closest;
        elseif c == 4
            fourr=fourr+1;
            four(fourr)=closest;
        end
        list(num,1:256)=filer(a,15:270);
        context(num,1:256)=filer(a,5647:5902);
        OBCG(num,1:256)=filer(a,5391:5646);
        CBOG(num,1:5120)=filer(a,271:5390);
        fprintf('object %d is closely related to object %d in list %d\n',a,closest,c);
    end
end
fprintf('there were %d objects from %s found\n',count1,file1);
fprintf('there were %d objects from %s found\n',count2,file2);
fprintf('there were %d objects from %s found\n',count3,file3);
fprintf('there were %d objects from %s found\n',count4,file4);
fprintf('there were %d objects from neither list\n',neither);

% lister=zeros(number,256*number);
% if num >= number
%     choice=randperm(num,number);
%     for i=1:number
%         lister(i)=list(choice(i));
%     end
% else
%     lister=list;
%     for i=(num+1):number
%         lister(i,1:256)=zeros(1,256);
%     end
% end         

% reshape(transpose(lister(count,:)),1,5120)
% CBOG(count,1:5120)

for count2=1:num
    dayout(count2,1:(1281+20*256))=[count2 list(count2,1:256) context(count2,1:256) list(count2,1:256) OBCG(count2,1:256) CBOG(count2,1:5120) context(count2,1:256)];
end
if one ~= 0
    one=sort(one);
    first=one(1);
    o=1;
    for a=1:oner
        if first ~= one(a)
            o=o+1;
            first=one(a);
        end
    end
    fprintf('%g nonrepeating objects from list 1\n',o);
end

if two ~= 0
    two=sort(two);
    first=two(1);
    t=1;
    for a=1:twor
        if first ~= two(a)
            t=t+1;
            first=two(a);
        end
    end
    fprintf('%g nonrepeating objects from list 2\n',t);
end
fileout=input('what would you like the input file to be named?: ','s');
csvwrite(fileout,dayout);