%Justin Lines 2013... This program creates inputs for Emergent with
%variable overlap. The inputs can be created such that list 3 objects have
%overlap or not with list 1 and list 2 objects depending on what is
%commented out in line 29 or 30. Also available is to overlap context C
%with contexts A and B with line 77.

clear

%reproduce function outlining object overlap

X=(0.001:0.001:0.978);
for i = 1:978
    A(i)=0.01274*exp(2.764*X(i))+(1.459e-14)*exp(32.33*X(i));
end
A(978)=1;
A(977)=1;
A(1)=0;
A(2)=0;
ans=0;

%create objects

while ans == 0
    over=input('what percent of overlap would you like?: ');
    over=over/100;
    list=zeros(40,256);
    list3=zeros(60,256);
    for t=1:978     %convert desired overlap into correct x value on overlap reproduction curve reproduced above (this is not a linear function)
        if ((over-(A(t+1)))*(over-(A(t)))) <= 0
            lap=round(256-(X(t)*256));
            break
        end
    end
    
    for a=1:40
        ran = randperm(lap,6);
        rando=randperm(256,6);      %used to give list3 ~5% overlap with lists 1 & 2
        for k = 1:6
            list(a,ran(k))=1;
            list3(a,rando(k))=1;
        end
    end
    for a=1:20
        rando=randperm(140,6);
        for k=1:6
            list3(40+a,rando(k))=1;
        end
    end
    %determine object overlap
    count=0;
    counts=0;
    counter=0;
    sumd=0;
    sume=0;
    sum1=0;
    for p=1:40
        for q=p+1:40
            sumd=sum(list(p,:).*list(q,:))/6 + sumd;
            count=count+1;
        end
    end
    
    for p=1:60
        for q=p+1:60
            sume=sum(list3(p,:).*list3(q,:))/6 + sume;
            counts=counts+1;
        end
    end
    
    for g=1:40
        for h=1:60
            sum1=sum(list(g,:).*list3(h,:))/6 + sum1;
            counter=counter+1;
        end
    end
    
    avg3=sume/counts;
    avg=sumd/count;
    avg1=sum1/counter;
    fprintf('The actual overlap of the created set is %g\n',avg*100)
    fprintf('List 3 overlaps is %d and total overlap between working lists and list 3 is %d\n',avg3,avg1)
    ans=input('reroll (push 0) ?');
    
    %Are you sure about that actual overlap?
    
end

%create context inputs

contexta=zeros(1,256);
contextb=contexta;
contextc1=contexta;
contextc2=contexta;
contextc3=contexta;

for s=1:256
    if s <= 128
        contexta(s)=1;
    else
        contextb(s)=1;
    end
    if rand > 0.5;
        contextc1(s)=1;
    end
    if rand > 0.5;
        contextc2(s)=1;
    end
    if rand > 0.5;
        contextc3(s)=1;
    end
end

%Lets write dem inputs

day1=zeros(20,6401);
day2R=day1;
day2NR=day1;
day31=day1;
day32=day1;
day33=day1;
for count=1:20
    day1(count,1:6401)=[count list(count,1:256) contexta list(count,1:256) contexta reshape(transpose(list(1:20,1:256)),1,5120) contexta];
    day2R(count,1:6401)=[count list(count+20,1:256) contexta list(count+20,1:256) contexta reshape(transpose(list(21:40,1:256)),1,5120) contexta];
    day2NR(count,1:6401)=[count list(count+20,1:256) contextb list(count+20,1:256) contextb reshape(transpose(list(21:40,1:256)),1,5120) contextb];
%     day31(count,1:6401)=[count list3(count,1:256) contextc1 list3(count,1:256) contextc1 reshape(transpose(list3(1:20,1:256)),1,5120) contextc1];
%     day32(count,1:6401)=[count list3(count+20,1:256) contextc2 list3(count+20,1:256) contextc2 reshape(transpose(list3(21:40,1:256)),1,5120) contextc2];
%     day33(count,1:6401)=[count list3(count+40,1:256) contextc3 list3(count+40,1:256) contextc3 reshape(transpose(list3(41:60,1:256)),1,5120) contextc3];
end
file1=input('what would you like the day1 file to be named?: ','s');
file2R=input('what would you like the day2R file to be named?: ','s');
file2NR=input('what would you like the day2NR file to be named?: ','s');
% file31=input('what would you like the day31 file to be named?: ','s');
% file32=input('what would you like the day32 file to be named?: ','s');
% file33=input('what would you like the day33 file to be named?: ','s');
csvwrite(file1,day1);
csvwrite(file2R,day2R);
csvwrite(file2NR,day2NR);
% csvwrite(file31,day31);
% csvwrite(file32,day32);
% csvwrite(file33,day33);