%Justin Lines 2014. checks outputs from EMERGENT against inputs

clear
filename=input('Give me the filename you wish to read: ','s');
filename2=input('Give me the other filename you wish to read: ','s');
file1='z1.dat';     %input file for day1
file2='zR.dat';    %input file for no reminder
file3='nomult_noise.dat'; %input file for noise
threshold=0.5;
entry=6;
filer=csvread(filename);
filer2=csvread(filename2);
number=size(filer,1);
object=zeros(size(filer,1)*16,16);
object2=zeros(size(filer,1)*16,16);
day1=csvread(file1);
day2=csvread(file2);
day3=csvread(file3);
correct1=zeros(320,16);
correct2=zeros(320,16);
compare=nan(size(filer,1),2);
compare2=nan(size(filer,1),5);
count=0;
counter=0;
neither=0;
oner=0;
twor=0;
one=0;
two=0;
correlation=0;
carrelation=0;
itemrecall=zeros(20,7); %Keep track of times object recalled/object similarity/ddCA1/pdCA1/dCA3/dDG/noise input with correct input
recalls=zeros(size(filer,1),1);
objectrecall=zeros(20,2);

for i=1:size(filer,1)   %make output objects into matrices
    object(((i*16)-15):(i*16),1:16)=transpose(reshape(filer(i,15:270),16,16));
    ddCA1(((i*20)-19):(i*20),1:20)=transpose(reshape(filer(i,5903:6302),20,20));
    pdCA1(((i*20)-19):(i*20),1:20)=transpose(reshape(filer(i,6703:7102),20,20));
    dCA3(((i*16)-15):(i*16),1:16)=transpose(reshape(filer(i,7503:7758),16,16));
    dDG(((i*20)-19):(i*20),1:40)=transpose(reshape(filer(i,8015:8814),40,20));
    dvCA1(((i*20)-19):(i*20),1:20)=transpose(reshape(filer(i,6303:6702),20,20));
    pvCA1(((i*20)-19):(i*20),1:20)=transpose(reshape(filer(i,7103:7502),20,20));
    vCA3(((i*16)-15):(i*16),1:16)=transpose(reshape(filer(i,7759:8014),16,16));
    vDG(((i*20)-19):(i*20),1:40)=transpose(reshape(filer(i,8815:9614),40,20));
end
for i=1:size(filer2,1)
    object2(((i*16)-15):(i*16),1:16)=transpose(reshape(filer2(i,15:270),16,16));
    ddCA12(((i*20)-19):(i*20),1:20)=transpose(reshape(filer2(i,5903:6302),20,20));
    pdCA12(((i*20)-19):(i*20),1:20)=transpose(reshape(filer2(i,6703:7102),20,20));
    dCA32(((i*16)-15):(i*16),1:16)=transpose(reshape(filer2(i,7503:7758),16,16));
    dDG2(((i*20)-19):(i*20),1:40)=transpose(reshape(filer2(i,8015:8814),40,20));
    dvCA12(((i*20)-19):(i*20),1:20)=transpose(reshape(filer2(i,6303:6702),20,20));
    pvCA12(((i*20)-19):(i*20),1:20)=transpose(reshape(filer2(i,7103:7502),20,20));
    vCA32(((i*16)-15):(i*16),1:16)=transpose(reshape(filer2(i,7759:8014),16,16));
    vDG2(((i*20)-19):(i*20),1:40)=transpose(reshape(filer2(i,8815:9614),40,20));
end
for i=1:20  %make input objects into matrices
    correct1(((i*16)-15):(i*16),1:16)=transpose(reshape(day1(i,2:257),16,16));
    correct2(((i*16)-15):(i*16),1:16)=transpose(reshape(day2(i,2:257),16,16));
end
for i=1:810 %make noise input objects into matrices
    noise(((i*16)-15):(i*16),1:16)=transpose(reshape(day3(i,2:257),16,16));
end


for a=1:size(filer,1)
    p=0;
    q=0;
    n=0;
    c=0;
    for b=1:20
        un=sum(sum(correct1((b*16-15):b*16,1:16).*object((a*16-15):a*16,1:16)))/sqrt(sum(sum(correct1((b*16-15):b*16,1:16)))*sum(sum(object((a*16-15):a*16,1:16))));
        deux=sum(sum(correct2((b*16-15):b*16,1:16).*object((a*16-15):a*16,1:16)))/sqrt(sum(sum(correct2((b*16-15):b*16,1:16)))*sum(sum(object((a*16-15):a*16,1:16))));
        if un >= threshold && un > p
            p=un;
            closest=b;
        end
        if deux >= threshold && deux > q
            q=deux;
            closest=b;
        end 
    end
    if p == 0 && q == 0
        neither=neither+1;
        n=1;
    end
    if p > q && n == 0
        counter=counter+1;
        c=1;
    end
    if q > p && n == 0
        count=count+1;
        c=2;
    end
    if c ~= 0   %if object belongs to one of the input lists
        if c == 1
            oner=oner+1;
            one(oner)=closest;
            cor=p;
            correlation=correlation+cor;
        else
            twor=twor+1;
            two(twor)=closest;
            cor=q;
            carrelation=carrelation+cor;
        end
        fprintf('object %d is related by %g to object %d in list %d\n',a,cor,closest,c);
        recalls(a)=cor;
        objectrecall(closest,1)=objectrecall(closest,1)+1;
        objectrecall(closest,2)=objectrecall(closest,2)+cor;
%         objnoise=floor(a/90)/10;
%         contmult=ceil(mod(a,90)/10);
%         fprintf('object noise %d and context mult %d\n',objnoise, contmult);
        tre=sum(sum(correct1((closest*16-15):closest*16,1:16).*noise((a*16-15):a*16,1:16)))/sqrt(sum(sum(correct1((closest*16-15):closest*16,1:16)))*sum(sum(noise((a*16-15):a*16,1:16)))); %compare noise input with correct input to show unrelatedness
%         fprintf('noise object %d is related by %d to object %d in list %d\n',a,tre,closest,c);
        compare(a,:)=[cor tre];
        quatre=sum(sum(object2((closest*16-15):closest*16,1:16).*object((a*16-15):a*16,1:16)))/sqrt(sum(sum(object2((closest*16-15):closest*16,1:16)))*sum(sum(object((a*16-15):a*16,1:16))));  %compare reactivated noise output with correct recall output to show relatedness
        cinq=sum(sum(ddCA12((closest*20-19):closest*20,1:20).*ddCA1((a*20-19):a*20,1:20)))/sqrt(sum(sum(ddCA12((closest*20-19):closest*20,1:20)))*sum(sum(ddCA1((a*20-19):a*20,1:20))));  %compare reactivated noise ddCA1 with correct recall ddCA1 to show relatedness
        six=sum(sum(pdCA12((closest*20-19):closest*20,1:20).*pdCA1((a*20-19):a*20,1:20)))/sqrt(sum(sum(pdCA12((closest*20-19):closest*20,1:20)))*sum(sum(pdCA1((a*20-19):a*20,1:20))));  %compare reactivated noise pdCA1 with correct recall pdCA1 to show relatedness
        sept=sum(sum(dCA32((closest*16-15):closest*16,1:16).*dCA3((a*16-15):a*16,1:16)))/sqrt(sum(sum(dCA32((closest*16-15):closest*16,1:16)))*sum(sum(dCA3((a*16-15):a*16,1:16))));  %compare reactivated noise dCA3 with correct recall dCA3 to show relatedness
        huit=sum(sum(dDG2((closest*20-19):closest*20,1:40).*dDG((a*20-19):a*20,1:40)))/sqrt(sum(sum(dDG2((closest*20-19):closest*20,1:40)))*sum(sum(dDG((a*20-19):a*20,1:40))));  %compare reactivated noise dCA3 with correct recall dCA3 to show relatedness
        compare2(a,:)=[quatre cinq six sept huit];
        itemrecall(closest,:)=[itemrecall(closest,1)+1 itemrecall(closest,2)+quatre itemrecall(closest,3)+cinq itemrecall(closest,4)+six itemrecall(closest,5)+sept itemrecall(closest,6)+huit itemrecall(closest,7)+tre];
%         cinqv=sum(sum(dvCA12((closest*20-19):closest*20,1:20).*dvCA1((a*20-19):a*20,1:20)))/sqrt(sum(sum(dvCA12((closest*20-19):closest*20,1:20)))*sum(sum(dvCA1((a*20-19):a*20,1:20))));  %compare reactivated noise dvCA1 with correct recall dvCA1 to show relatedness
%         sixv=sum(sum(pvCA12((closest*20-19):closest*20,1:20).*pvCA1((a*20-19):a*20,1:20)))/sqrt(sum(sum(pvCA12((closest*20-19):closest*20,1:20)))*sum(sum(pvCA1((a*20-19):a*20,1:20))));  %compare reactivated noise pvCA1 with correct recall pvCA1 to show relatedness
%         septv=sum(sum(vCA32((closest*16-15):closest*16,1:16).*vCA3((a*16-15):a*16,1:16)))/sqrt(sum(sum(vCA32((closest*16-15):closest*16,1:16)))*sum(sum(vCA3((a*16-15):a*16,1:16))));  %compare reactivated noise vCA3 with correct recall vCA3 to show relatedness
%         huitv=sum(sum(vDG2((closest*20-19):closest*20,1:40).*vDG((a*20-19):a*20,1:40)))/sqrt(sum(sum(vDG2((closest*20-19):closest*20,1:40)))*sum(sum(vDG((a*20-19):a*20,1:40))));  %compare reactivated noise vCA3 with correct recall vCA3 to show relatedness
%         compare2(a,6)=cinqv;
%         compare2(a,7)=sixv;
%         compare2(a,8)=septv;
%         compare2(a,9)=huitv;
    end
end

fprintf('there were %d objects from list 1 found\n',counter);
fprintf('there were %d objects from list 2 found\n',count);
fprintf('there were %d objects from neither list\n',neither);
meaner=nanmean(compare);
fprintf('there was %g output overlap and %g input overlap\n',meaner(1),meaner(2));
meaner2=nanmean(compare2);
fprintf('there was %g overlap between output object guesses\n',meaner2(1));
fprintf('there was %g overlap between ddCA1\n',meaner2(2));
fprintf('there was %g overlap between pdCA1\n',meaner2(3));
fprintf('there was %g overlap between dCA3\n',meaner2(4));
fprintf('there was %g overlap between dDG\n',meaner2(5));

if one ~= 0
    one=sort(one);
    first=one(1);
    o=1;
    for a=1:oner
        if first ~= one(a)
            o=o+1;
            first=one(a);
        end
    end
    fprintf('%g nonrepeating objects from list 1\n',o);
    fprintf('Correlation per object from list 1 is %g\n',correlation/oner);
    fprintf('Correlation per object from list 2 is %g\n',carrelation/twor);
end

if two ~= 0
    two=sort(two);
    first=two(1);
    t=1;
    for a=1:twor
        if first ~= two(a)
            t=t+1;
            first=two(a);
        end
    end
    fprintf('%g nonrepeating objects from list 2\n',t);
end

%% PLAY with itemrecall
i=1;
while i<=length(itemrecall)
    itemrecall(i,2:7)=itemrecall(i,2:7)/itemrecall(i,1);
    if itemrecall(i,1)==0
        itemrecall(i,:)=[];
    else
        i=i+1;
    end
end
% subplot(3,2,1), plot(itemrecall(:,1),itemrecall(:,2),'.','MarkerSize',20), xlabel('recall#'), ylabel('%objectguess')
% subplot(3,2,2), plot(itemrecall(:,1),itemrecall(:,3),'.','MarkerSize',20), xlabel('recall#'), ylabel('%ddCA1')
% subplot(3,2,3), plot(itemrecall(:,1),itemrecall(:,4),'.','MarkerSize',20), xlabel('recall#'), ylabel('%pdCA1')
% subplot(3,2,4), plot(itemrecall(:,1),itemrecall(:,5),'.','MarkerSize',20), xlabel('recall#'), ylabel('%dCA3')
% subplot(3,2,5), plot(itemrecall(:,1),itemrecall(:,6),'.','MarkerSize',20), xlabel('recall#'), ylabel('%dDG')
% subplot(3,2,6), plot(itemrecall(:,1),itemrecall(:,7),'.','MarkerSize',20), xlabel('recall#'), ylabel('%noise input')
corry=corrcoef(itemrecall);
corry(:,2)
objectrecall(:,2)=objectrecall(:,2)./objectrecall(:,1);
objectrecall(:,1)
objectrecall(:,2)




